%
%  Globec Raw Drifter Data 1995-1996

% The preceding empty line is important
% $Log: gbdrift.m,v $
% Revision 1.2  2000/02/24 19:53:52  kwoklin
% Recommit for previous changes.     klee
%
% Revision 1.1  1999/06/01 07:10:29  dbyrne
%
%
% Moved up from kleedata/
%
% Revision 1.3  1999/05/28 22:53:04  kwoklin
% Point to new server for all jgofs datasets. Update getjgsta on loaddods.
% Fix infotext for all gb geturl files. Fix transmissivity for some gb
% files. Modify some variable names on gb files.       klee
%

% $Id: gbdrift.m,v 1.2 2000/02/24 19:53:52 kwoklin Exp $
%  klee 03/99

GetFunctionName = 'getjgsta';

Server = 'http://maewest.gso.uri.edu/cgi-bin/nph-jg/drifter'; %don't forget to add 1995/96 afterwards 
CatalogServer = nan;
Cat_m_File = 'gbdriftc';
URL_m_File = 'gbdriftu';

LonRange = [-80 -10];
LatRange = [10 52];
TimeRange = [1995.03405452 2000];
DepthRange = [0.0 0.0];
Resolution = nan;

DodsName1 = str2mat('yrday_gmt','sequence_no');
DodsName = str2mat('lon','lat','temp');
DataName = 'Drifter -- Drifter Raw Data -- WHOI/GLOBEC';   
LongitudeName = 'lon';
LatitudeName = 'lat';
TimeName = 'yrday_gmt';         
DepthName = '';
DepthUnits = '';
SelectableVariables = str2mat('Longitude','Latitude','Sea_Temp');
OptionalVariables = str2mat('submergence','sequence_no','temp');
SelectableOptional = str2mat('Submergence','Sequence_No','Sea_Temp');

Acknowledge = [];
Data_Use_Policy = sprintf('%s' ,...
      'Any person making substantial use of a data set must communicate with the investigators who acquired the data prior to publication and anticipate that the data collectors will be co-authors of published results. This extends to model results and to data organized for retrospective studies. (Please refer to U.S. GLOBEC''s data policy Report #10 (http://cbl.umces.edu/fogarty/usglobec/reports/datapol/ datapol.contents.html).) The data available here are intended for scholarly use by the academic and scientific community, with the express understanding that any such use will properly acknowledge the originating investigator. Use or reproduction of any material herein for any commercial purpose is prohibited without prior written permission from the U.S. GLOBEC Georges Bank Data Management Office. (http://globec.whoi.edu/globec-dir/contact_dmo.html)');

%COMMENTS
Comments1 = sprintf('%s\n', ...
'                       Globec Raw Drifter Data 1995-1996                ',...
'   ',...
'                   Parameter         Description                    Units',...
'                 ----------------------------------------------------------',...
'                   sequence_no       drifter sequence number        n/a',...
'                   lat               latitude                       decimal degrees',...
'                   lon               longitude                      decimal degrees',...
'                   temp              temperature                    degrees C',...
'                   submergence       from drogue sensor      ',...
'                   year_utc          year drifter deployed          UTC',...
'   ',...
'For the drogue submergence status word: a value of 70 to 120 is normal, greater than 120 may',...
'indicate biological fouling of the drogue, and 0 to 20 means the drogue is off. ',...
'   ',...
'Drifters g1 to g10 had 7.5 m drogues centered at 15 m. Drifters g11 to g36 had 7.5 m drogues ',...
'centered at 10 m. ');

Comments4 = sprintf('%s\n', ...
'   ', ...
'    Time_Period_of_Content = ', ...
'         Beginning_Date: Jan. 13, 1995 (1995.03405452)', ...
'         Ending_Date:    Jun. 14, 1999 (1999.45229397)', ...
'    Spatial_Domain = ', ...
'         Bounding Coordinates: ', ...
'              West Bounding Coordinate: 77.1390 W ', ...
'              East Bounding Coordinate: 13.2470 W ', ...
'              South Bounding Coordinate: 21.8620 N ', ...
'              North Bounding Coordinate: 50.6420 N ', ....
'   ', ...
'    Point_of_Contact = ', ...
'         Address - si: ', ...
'               Richard Limeburner', ...
'               Clark 343A, MS #21 ',...
'               Woods Hole, MA 02543-1541 ',...
'               USA ', ...
'               FAX: 508-457-2181 ',...
'               Electronic Mail Address:INTERNET > rlimeburner@whoi.edu',...
'         Address - globec: ',...
'               Robert Groman',...
'               Swift House MS# 38',...
'               Woods Hole, MA 02543-1127',...
'               USA ',...
'               Electronic Mail Address:INTERNET > rgroman@whoi.edu',...
'               FAX: (508) 457-2169',...
'         Address - dods: ',...
'               Electronic Mail Address:INTERNET > support@unidata.ucar.edu ');

Comments = [Comments1 Comments4];