function [url,loaddodsbool,infotext] = gbmcmurl ...
         (getarchive, getranges, getmode, getvariablelist, getserverlist, passtimes, passdepths, whichurl)
%
%    This function will build gbmcm file names and return infotext and time/depth/lat/lon/url
%    to the browser
%

% The preceding empty line is important
% $Log: gbmcmurl.m,v $
% Revision 1.4  1999/07/21 15:35:53  dbyrne
%
%
% Corrected language in Acknowledgements.  --dbyrne 99/07/21
%
% Revision 1.3  1999/06/24 19:05:00  kwoklin
% Change file name of nbnerr.m. Fix some display bugs, define precision level
% of lat/lon/depth/time, and fix some more bugs in globec files.        klee
%
% Revision 1.2  1999/06/01 16:12:37  dbyrne
%
%
% quick bug fixes for AGU -- dbyrne 99/06/01
%
% Revision 1.1  1999/06/01 07:10:30  dbyrne
%
%
% Moved up from kleedata/
%
% Revision 1.3  1999/05/28 22:53:04  kwoklin
% Point to new server for all jgofs datasets. Update getjgsta on loaddods.
% Fix infotext for all gb geturl files. Fix transmissivity for some gb
% files. Modify some variable names on gb files.       klee
%

% $Id: gbmcmurl.m,v 1.4 1999/07/21 15:35:53 dbyrne Exp $
% klee 04/01/99

if exist(getarchive) == 2   
  eval(getarchive)
else
  dodsmsg('Metadata not found!')
  return
end

url = []; infotext = []; text = []; Constraint = []; loaddodsbool = 1;
URLdepth = []; URLlat = []; URLlon = [];

URLdepth = ['&depth>=', num2str(passtimes(whichurl,4),7), '&depth<=', num2str(passtimes(whichurl,5),7)];
URLlat = ['&latitude>=', num2str(passtimes(whichurl,6),4), '&latitude<=', num2str(passtimes(whichurl,7),4)];
% for [-180, 180]  
URLlon = ['&longitude>=', num2str(passtimes(whichurl,8),4), '&longitude<=', num2str(passtimes(whichurl,9),4)];
Constraint = [Constraint, URLdepth, URLlat, URLlon]; 

StartYear = passtimes(whichurl,1);
StartYrday = passtimes(whichurl,2);
EndYrday = passtimes(whichurl,3);
whichserver = passtimes(whichurl,10);
Constraint = [Constraint, '&yrday_utc>=', num2str(StartYrday,7), '&yrday_utc<=', num2str(EndYrday,7)];

returned_var = [];
for i = 1:size(getvariablelist,1)
  returned_var = [returned_var, dods_dbk(getvariablelist(i,:))];  
  if i < size(getvariablelist,1)
    returned_var = [returned_var, ','];
  end
end

returned_var = [returned_var, ',', deblank(OptionalVariables(1,:))];
TmpServer = str2mat('93_fall','94_spring','94_fall','95_spring','95_sumfal','95_falwin','96_winsum');
server = [Server, deblank(TmpServer(whichserver,:))];
url = [server, '?', returned_var, Constraint];

tmpvar = ['?site,yrday_utc'];
tmptext = ['loaddods ''', server, tmpvar, Constraint, ''''];

infotext = sprintf('%s\n%s\n%s\n%s\n%s\n%s\n','   ',...
                  ['"Site" name is stored as a character variable. Searches on character variables',...
                  ' are not supported by this version of the DODS Matlab GUI.',...
                  '   ',...
                  '** To get Site information ** ',...
                  'please issue the ''loaddods'' command from the MATLAB prompt line, using a URL like this:',...
                  '   '], ...
                  ['URL = ',server], ...
                  ['Proj = ',tmpvar] ,...
                  ['Sel = ',Constraint], ...
                  ['   '],...
                  ['They will return a set of date, depth and site vectors corresponding to each other.']);

return

  

  

  
